"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/helper/index.ts
var helper_exports = {};
__export(helper_exports, {
  defineTypeFactory: () => defineTypeFactory,
  dynamic: () => dynamic,
  resetAllSequence: () => resetAllSequence,
  resetSequence: () => resetSequence
});
module.exports = __toCommonJS(helper_exports);

// src/helper/field-resolver.ts
var Dynamic = class {
  constructor(factory) {
    this.factory = factory;
  }
  async get(options) {
    return this.factory(options);
  }
};
function dynamic(factory) {
  return new Dynamic(factory);
}
async function resolveFields(transientFieldNames, seq, defaultFieldsResolver, inputFieldsResolver) {
  const fields = {};
  async function resolveField(options2, fieldResolver) {
    if (fieldResolver instanceof Dynamic) {
      return fieldResolver.get(options2);
    } else {
      return fieldResolver;
    }
  }
  async function resolveFieldAndUpdateCache(fieldName) {
    if (fieldName in fields)
      return fields[fieldName];
    let fieldResolver;
    if (fieldName in inputFieldsResolver) {
      fieldResolver = inputFieldsResolver[fieldName];
    } else if (fieldName in defaultFieldsResolver) {
      fieldResolver = defaultFieldsResolver[fieldName];
    } else {
      return void 0;
    }
    fields[fieldName] = await resolveField(options, fieldResolver);
    return fields[fieldName];
  }
  const options = {
    seq,
    get: resolveFieldAndUpdateCache
  };
  for (const fieldName of [...Object.keys(defaultFieldsResolver), ...Object.keys(inputFieldsResolver)]) {
    await resolveFieldAndUpdateCache(fieldName);
  }
  return Object.fromEntries(Object.entries(fields).filter(([key]) => !transientFieldNames.includes(key)));
}

// src/helper/sequence.ts
var sequenceCounterMap = /* @__PURE__ */ new Map();
function getSequenceCounter(key) {
  const c = sequenceCounterMap.get(key);
  if (c === void 0) {
    sequenceCounterMap.set(key, 0);
    return 0;
  }
  sequenceCounterMap.set(key, c + 1);
  return c + 1;
}
function resetSequence(key) {
  sequenceCounterMap.delete(key);
}
function resetAllSequence() {
  sequenceCounterMap = /* @__PURE__ */ new Map();
}

// src/helper/factory.ts
var import_graphql_relay = require("graphql-relay");
function defineTypeFactoryInternal(transientFieldNames, {
  defaultFields: defaultFieldsResolver,
  traits
}, seqKey = {}) {
  const getSeq = () => getSequenceCounter(seqKey);
  return {
    async build(inputFieldsResolver) {
      const seq = getSeq();
      return resolveFields(
        transientFieldNames,
        seq,
        defaultFieldsResolver,
        inputFieldsResolver ?? {}
      );
    },
    async buildList(count, inputFieldsResolver) {
      const array = [];
      for (let i = 0; i < count; i++) {
        if (inputFieldsResolver) {
          array.push(await this.build(inputFieldsResolver));
        } else {
          array.push(await this.build());
        }
      }
      return array;
    },
    async buildConnection(count, connectionArgs, inputFieldsResolver) {
      const list = inputFieldsResolver ? await this.buildList(count, inputFieldsResolver) : await this.buildList(count);
      return (0, import_graphql_relay.connectionFromArray)(
        list,
        connectionArgs
      );
    },
    use(traitName) {
      const trait = traits?.[traitName];
      if (!trait)
        throw new Error(`Trait ("${String(traitName)}") is not defined.`);
      return defineTypeFactoryInternal(
        transientFieldNames,
        {
          defaultFields: { ...defaultFieldsResolver, ...trait.defaultFields },
          traits
        },
        seqKey
      );
    },
    resetSequence() {
      resetSequence(seqKey);
    }
  };
}
var DefineTypeFactory = class _DefineTypeFactory extends Function {
  _defaultTransientFields;
  constructor(defaultTransientFields) {
    super();
    this._defaultTransientFields = defaultTransientFields;
    return new Proxy(this, {
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      apply: (target, _thisArg, [options]) => target._apply(options)
    });
  }
  _apply(options) {
    return defineTypeFactoryInternal(
      Object.keys(this._defaultTransientFields),
      {
        ...options,
        defaultFields: { ...this._defaultTransientFields, ...options.defaultFields }
      }
    );
  }
  withTransientFields(defaultTransientFields) {
    return new _DefineTypeFactory({ ...this._defaultTransientFields, ...defaultTransientFields });
  }
  withAdditionalFields() {
    return this;
  }
};
var defineTypeFactory = new DefineTypeFactory({});
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  defineTypeFactory,
  dynamic,
  resetAllSequence,
  resetSequence
});
//# sourceMappingURL=index.cjs.map