import { ConvertFn, RawTypesConfig } from '@graphql-codegen/visitor-plugin-common';
export type RawConfig = {
    typesFile: string;
    skipTypename?: RawTypesConfig['skipTypename'];
    skipIsAbstractType?: boolean | undefined;
    nonOptionalDefaultFields?: boolean | undefined;
    namingConvention?: RawTypesConfig['namingConvention'];
    typesPrefix?: RawTypesConfig['typesPrefix'];
    typesSuffix?: RawTypesConfig['typesSuffix'];
};
export type Config = {
    typesFile: string;
    skipTypename: Exclude<RawTypesConfig['skipTypename'], undefined>;
    skipIsAbstractType: boolean;
    nonOptionalDefaultFields: boolean;
    typesPrefix: Exclude<RawTypesConfig['typesPrefix'], undefined>;
    typesSuffix: Exclude<RawTypesConfig['typesSuffix'], undefined>;
    convert: ConvertFn;
};
export declare function validateConfig(rawConfig: unknown): asserts rawConfig is RawConfig;
export declare function normalizeConfig(rawConfig: RawConfig): Config;
//# sourceMappingURL=config.d.ts.map